︠9c087ea5-627d-4e5e-b3e8-7326f38a1603is︠
%hide
%md
# <span style='color:blue'> Math </span>
## <span style='color:brown'>Quiz: Chain Rule and Product Rules</span>

### <span style='color:red'>Please Explain </span>
︡83e768c9-6046-431b-8865-c0fccfa64bba︡{"hide":"input"}︡{"md":"# <span style='color:blue'> Math </span>\n## <span style='color:brown'>Quiz: Chain Rule and Product Rules</span>\n\n### <span style='color:red'>Please Explain </span>"}︡{"done":true}
︠fd29fc90-de57-45d7-8703-4a63ab02e7c7is︠
%hide
%latex
\begin{flushleft}
There are two function of x\\
$a(x),b(x)$\\
By product rules, we know\\
$$\frac{d(a(x)b(x))}{dx}=a'(x)b(x)+a(x)b'(x)$$
But we also know chain rule\\
$$\frac{d(f(g(x)))}{dx}=\frac{df}{dg}\frac{dg}{dx}$$
Why can't we use chain rule:
$$\frac{d(ab)}{dx} =\frac{d(ab)}{da}\frac{da}{dx}=ba'(x)$$
\end{flushleft}
︡30e3058d-9314-43d5-89c3-80cf08fdec12︡{"hide":"input"}︡{"file":{"filename":"/tmp/tmpvPqEUC.png","show":true,"text":null,"uuid":"e297d541-9e45-429f-8040-d3912d4b27a6"},"once":false}︡{"done":true}
︠4c0ec3f4-4074-4719-a4e1-dd5bb722122ais︠
%hide
%md
## <span style='color:brown'>Quiz: Integration and Linear Approximation</span>
Please explain the pink area in the below area can be calculated as follows:

︡76ccebba-f1c5-440e-8095-2432988d1718︡{"hide":"input"}︡{"md":"## <span style='color:brown'>Quiz: Integration and Linear Approximation</span>\nPlease explain the pink area in the below area can be calculated as follows:"}︡{"done":true}
︠0fe354aa-21c0-46f7-a3a5-22f3d729b94dis︠
%hide
%latex
\begin{flushleft}
If $\frac{dF(t)}{dt}=f(t)$\\
The pink area is:
$ F(t)-F(0)$

Think about "Linear Approximation"
\end{flushleft}
︡bc888aa2-c7b3-468a-b6fc-577dbc3f1802︡{"hide":"input"}︡{"file":{"filename":"/tmp/tmpuc9rYo.png","show":true,"text":null,"uuid":"d8cb9549-5cdf-4436-9644-f97ab73dd8dc"},"once":false}︡{"done":true}
︠33938180-ccbb-4484-a765-169e74a560c4is︠
%hide
%md
![](integration.jpg)
<br><br><br><br><br><br>
︡8848fd60-6faf-47e8-81d8-432c339ec9b1︡{"hide":"input"}︡{"md":"![](integration.jpg)\n<br><br><br><br><br><br>"}︡{"done":true}
︠51220910-fbb5-4838-881c-2e7951f084b4is︠
%hide
%latex
\begin{flushleft}
Answer:\\
Recall $$\lim_{\triangle t \rightarrow 0}F(t+\triangle t)-F(t)=f(t)\triangle t$$

Area = $$f(0)\triangle t+f(\triangle t)\triangle t+f(2\triangle t)\triangle t+f(3\triangle t)\triangle t+\dots+f(t-\triangle t)\triangle t$$\\
$$=F(t+\triangle t)-F(t)+F(t+2\triangle t)-F(t+\triangle t)+F(t+3\triangle t)-F(t+2\triangle t)\dots+F(t)-F(t-\triangle t)$$
 $$=F(t)-F(0)$$
\end{flushleft}
︡388fe63c-8316-4762-b748-782618e660f7︡{"hide":"input"}︡{"file":{"filename":"/tmp/tmpHLpT3M.png","show":true,"text":null,"uuid":"9881b6c2-c1ca-41ac-9f00-c83bf30cf264"},"once":false}︡{"done":true}
︠6ae0f8e8-1d34-4b88-9f32-0b4e01a7a36bi︠
%hide
%md
# <span style='color:blue'>Programming</span>

## <span style = 'color:brown'>IF AND ELSE</span>
<br>

### <span style='color:red'>Make Decision!</span>
![](if_else_statement.jpg)
### <span style='color:red'>Else is "what to do" if all if statements return False </span>
<br><br><br>
## <span style = 'color:red'>Different Priority</span>
Not all decisions have the same priority!
<br>
### Example: Buying Dinner
![](else_if.jpg)

<span style='color:red'> You will not check your walet before you are hungry!!!</span>
If hungry => If have money => Buy Dinner!

<br><br><br>
BTW, the graph I used are called "Flow Chart", which is common in programming
Basically, diamonds mean decisions, rectangles means actions!
<br><br><br>
### <span style='color:red'> Python Syntax </span>
︡4609b9ca-3391-4578-8a54-eccf80ddbb37︡{"hide":"input"}︡{"md":"# <span style='color:blue'>Programming</span>\n\n## <span style = 'color:brown'>IF AND ELSE</span>\n<br>\n\n### <span style='color:red'>Make Decision!</span>\n![](if_else_statement.jpg)\n### <span style='color:red'>Else is \"what to do\" if all if statements return False </span> \n<br><br><br>\n## <span style = 'color:red'>Different Priority</span>\nNot all decisions have the same priority!\n<br>\n### Example: Buying Dinner\n![](else_if.jpg)\n\n<span style='color:red'> You will not check your walet before you are hungry!!!</span>\nIf hungry => If have money => Buy Dinner!\n\n<br><br><br>\nBTW, the graph I used are called \"Flow Chart\", which is common in programming\nBasically, diamonds mean decisions, rectangles means actions!\n<br><br><br>\n### <span style='color:red'> Python Syntax </span>"}︡{"done":true}
︠f214d5ff-59af-4c5f-bea4-9a22723e8722︠
var1 = 10
if var1 == 8:
    print("var1 is 8")
elif var1 == 9:
    print("var1 is 9 ")
elif var1 == 10:
    print("var1 is 10")
else:
    print("var1 is not 8,9,10")
︡65a31729-4ff9-465c-82b3-1647b94ff3d4︡{"stdout":"var1 is 10\n"}︡{"done":true}
︠bd04ba21-b5fc-45b2-a211-8e18394afc37i︠
%hide
%md
### What if var1 = 11?
<br><br><br><br>
## <span style='color:brown'>Relational operator</span>
- a<b: Is a less than b?
- a>b: Is a larger than b?
- a == b: Is a equal to b?
- a>=b: Is a larger or equal to b?
- a<=b: Is a less or equal to b?
︡440c08c1-aa22-4e87-8252-5b8dc30573a1︡{"hide":"input"}︡{"md":"### What if var1 = 11? \n<br><br><br><br>\n## <span style='color:brown'>Relational operator</span>\n- a<b: Is a less than b?\n- a>b: Is a larger than b?\n- a == b: Is a equal to b?\n- a>=b: Is a larger or equal to b?\n- a<=b: Is a less or equal to b?"}︡{"done":true}
︠0b2104bc-73a4-4c09-bc58-53d7c1558612︠
a=1
b=2
c=2

a>b
a==c
b>=c
b>c
︡922ea236-b8c8-44a8-9cbf-86a99c5c19d6︡{"stdout":"False\n"}︡{"stdout":"False\n"}︡{"stdout":"True\n"}︡{"stdout":"False\n"}︡{"done":true}
︠80375096-fb70-4d11-aa82-8ae0c9b6b049i︠
%hide
%md
## <span style='color:brown'> Comapre Strings</span>
︡90a60307-46b2-46ab-a624-63c0b951b0ab︡{"hide":"input"}︡{"md":"## <span style='color:brown'> Comapre Strings</span>"}︡{"done":true}
︠ca432cf1-223e-4e7f-9abb-dbd742edc4dc︠
s1 = 'string1'
s2 = 'string2'


s1 == s2
s1[0:6]==s2[0:6]
︡59c8b262-4c62-4c21-84bf-92c6e6d29540︡{"stdout":"False\n"}︡{"stdout":"True\n"}︡{"done":true}
︠c7a74aa4-6a0c-44c6-81c4-411a710ec9ecis︠
%hide
%md
## <span style='color:brown'>While Loop</span>
<br><br>
- We have learned for loop when we need to do repeated task.
- What if we don't know how many loops we need?
<br>

## <span style='color:green'>Wait? Then when should we end?</span>
<br>

### <span style='color:red'>Use if/else statement</span>
```
while(decision!):
    things you want to do in the loop!
```
<br>

##### Example: Print all integers square is less than 100
︡1f6feb73-2f48-4cb5-b3a9-1f20449ce128︡{"hide":"input"}︡{"md":"## <span style='color:brown'>While Loop</span>\n<br><br>\n- We have learned for loop when we need to do repeated task.\n- What if we don't know how many loops we need?\n<br>\n\n## <span style='color:green'>Wait? Then when should we end?</span>\n<br>\n\n### <span style='color:red'>Use if/else statement</span>\n```\nwhile(decision!):\n    things you want to do in the loop!\n```\n<br>\n\n##### Example: Print all integers square is less than 100\n"}︡{"done":true}
︠dc4f024c-ccce-4be2-8f89-c72a41ea8d9es︠
startNum=0
while(startNum^2<100):
    print(startNum)
    startNum+=1

︡9c8a5663-0ee3-43df-84d4-7b04b14e6318︡{"stdout":"0\n1\n2\n3\n4\n5\n6\n7\n8\n9\n"}︡{"done":true}
︠0a2b4c93-baa1-44da-9a25-4e8f62656724i︠
%hide
%md
### Exercise 15 is quite difficult
Goal: Comapring 2 list with same length!
example:
︡b5316e7f-a84c-40f8-aeac-6965eb6f128f︡{"hide":"input"}︡{"md":"### Exercise 15 is quite difficult\nGoal: Comapring 2 list with same length!\nexample:"}︡{"done":true}
︠a0dd255a-2360-4d34-8da6-ec0fd7ac3c82s︠
from haoSecretFun import compareList #of course I will not let you see my code!!!!
#Hint: you may need 2 for loops!


list1 = ["cat","dog","rabbit","pig"]
list2 = ["horse","cat","dog","pig"]
table(compareList(list1,list2))

︡6f76fc4e-1a2c-45cb-9bb1-a1cc819339b3︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1188, in execute\n    flags=compile_flags) in namespace, locals\n  File \"\", line 1, in <module>\nImportError: cannot import name compareList\n"}︡{"done":true}︡
︠834725ce-2147-42d0-b25a-41ae6334ce3c︠










